package com.V10lator.SignClock;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.ChatColor;

public class CommandParser implements CommandExecutor
{
	private final SignClock plugin;
	
	public CommandParser(final SignClock plugin)
	{
	  this.plugin = plugin;
	}
	
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
	{
      if (!(sender instanceof Player)) return true;
	  if(commandLabel.equalsIgnoreCase("SignClock"))
	  {
	    if(args.length != 0)
    	  return true;
	    
	    if(!((Player)sender).hasPermission("SignClock.toggle"))
	    {
	      return true;
	    }
	    
	    if(this.plugin.permissionsActive())
	    {
	      this.plugin.setPermissions(false);
	      sender.sendMessage(ChatColor.YELLOW + "Pemissions deactivated.");
	      return true;
	    }
	    this.plugin.setPermissions(true);
	    sender.sendMessage(ChatColor.GREEN + "Pemissions activated.");
	  }
	  return true;
	}
}