package com.V10lator.SignClock;

import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.ChatColor;

public class SignClockPlayerListener extends PlayerListener
{
  private final SignClock plugin;
  
  public SignClockPlayerListener(final SignClock plugin)
  {
    this.plugin = plugin;
  }
  
  public void onPlayerInteract(PlayerInteractEvent event)
  {
	if(event.getAction() == Action.RIGHT_CLICK_BLOCK)
	{
	  Player player = event.getPlayer();
	  Block block = event.getClickedBlock();
      
      SClock SClock = plugin.getSignClock(block);
	  if(SClock == null)
		return;
      if(!plugin.hasPermission(event.getPlayer(), "theme"))
      {
    	event.setCancelled(true);
    	return;
      }
	  int tmp = plugin.themeLib.getThemeID(SClock.getStyle()) + 1;
	  
	  String themeName = "1";
	  try
	  {
	    themeName = plugin.themeLib.ThemeNames.get(tmp);
	  }
	  catch(IndexOutOfBoundsException ioe)
	  {
		themeName = plugin.themeLib.ThemeNames.get(0);
		
	  }
	  SClock.setStyle(themeName);
	  player.sendMessage(ChatColor.YELLOW + "SignClock " + ChatColor.BLUE + "has style " + themeName);	
	}
	else if(event.getAction() == Action.LEFT_CLICK_BLOCK)
	{
	  Player player = event.getPlayer();
	  Block block = event.getClickedBlock();
	  
	  SClock SClock = plugin.getSignClock(block);
	  if(SClock == null)
		return;
	  if(!plugin.hasPermission(event.getPlayer(), "theme"))
      {
    	event.setCancelled(true);
    	return;
      }
	  int tmp = plugin.themeLib.getThemeID(SClock.getStyle()) - 1;
		  
	  String themeName = "1";
	  try
	  {
	    themeName = plugin.themeLib.ThemeNames.get(tmp);
	  }
	  catch(IndexOutOfBoundsException ioe)
	  {
	    themeName = plugin.themeLib.ThemeNames.get(plugin.themeLib.themes.size() - 1);
	  }
	  SClock.setStyle(themeName);
	  player.sendMessage(ChatColor.YELLOW + "SignClock " + ChatColor.BLUE + "has style " + themeName);	
	}
  }
}
