package com.V10lator.SignClock;

import java.util.ArrayList;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.Material;
import org.bukkit.World;
import com.V10lator.lib24time.lib24time;

public class triggerTicker extends Thread {
	private final SignClock plugin;
	private final ArrayList<String> omarquees = new ArrayList<String>();
    private final ArrayList<char[]> emarquees = new ArrayList<char[]>();
	private int tc = 0;
    
	public triggerTicker(final SignClock plugin)
	{
	  this.plugin = plugin;
	  String[] dts = lib24time.getDaytimes();
	  for(String dt: dts)
	  {
		this.omarquees.add(dt);
		String org = dt;
		dt = dt + "  ";
		this.emarquees.add(dt.toCharArray());
		this.plugin.setMarquee(org, dt.substring(0,5));
	  }
	}
	
	public void run()
	{
		int cl = 0;
		int worlds = plugin.triggerRAM.getTriggerWorlds();
		int mc = 0;
		char tmp;
		while(cl < worlds)
		{
		  tc++;
		  //This seems to be a good place for the marquee...
		  //First: slow it down!
		  if(tc > 8)
		  {
		    tc = 0;
		    int mcc = 0;
		    for(char[] mq: this.emarquees)
		    {
		      mc = 0;
		      tmp = mq[0];
		      while(mc < mq.length - 1)
		      {
		        mq[mc] = mq[mc + 1];
		        mc++;
		      }
		      mq[mq.length - 1] = tmp;
		      this.plugin.replaceMarquee(this.omarquees.get(mcc), String.valueOf(mq).substring(0,5));
			  mcc++;
		    }
		  }
			
		  String sWorld = plugin.triggerRAM.getTriggerWorld().get(cl);
		  ArrayList<Integer> sCoords = plugin.triggerRAM.getTriggerCoords().get(cl);
		  
		  World world = plugin.getServer().getWorld(sWorld);
		  Block block = world.getBlockAt(sCoords.get(0), sCoords.get(1), sCoords.get(2));
		  if(block.getType() == Material.SIGN_POST || block.getType() == Material.WALL_SIGN)
          {
		    Sign sign = (Sign)block.getState();
		    SClock SClock = plugin.getSignClock(block);
		 
	        //write the new lines
		    String libout = lib24time.getTime(block.getWorld());
//		    String daymarquee = plugin.themeLib.getMarquee(plugin.l24t.getDaytime(block.getWorld()));
		    String daymarquee = this.plugin.getMarquee(lib24time.getDaytime(block.getWorld()));
			String frame = plugin.themeLib.getFrame(SClock.getStyle()).replace("[TIM]",libout);
			if(daymarquee != null)
			  frame = frame.replace("[DTC]", daymarquee);

	        String zeilen[] = frame.split("\n");
	        sign.setLine(0, "");
	        sign.setLine(1, "");
	        sign.setLine(2, "");
	        sign.setLine(3, "");
	        int fl = zeilen.length;
	        int c = 0;
	        while(c < fl)
	        {
	          if(c > 3)
	    	    break;
	          if(zeilen[c] != null)
	          {
	        	if(zeilen[c].length() > 15)
	              sign.setLine(c, zeilen[c].substring(0,14));
	          	else
	           	  sign.setLine(c, zeilen[c]);
	          }
	          c++;
	        }

	        sign.update();
		  }
	      cl++;
		}
	}
}
